<?

if (isset($lstatus) && $lstatus == $PHPSESSID) {

//Define the directory
$newsdir = $DOCUMENT_ROOT . '/admin/news';

if (!isset($mode)) {
$mode = 'index';
}

// Create a directory for news entries if one doesn't already exist.
if (!is_dir("$DOCUMENT_ROOT/admin/news/")) {
  @mkdir("$DOCUMENT_ROOT/admin/news/", 0777);
}


if (!isset($numshow)) {
  $numshow = '5';
}

switch($mode) {
case 'index': /* Display entries by default */
  echo"<DIV CLASS=headline>News Center</DIV>";
  echo "<HR>";
  echo " <A HREF=$PHP_SELF?mode=add_entry>Add an entry</A>";
  echo "<HR>";
  $entries=opendir("$newsdir");
  // Load files into an array  
  $files = array();           
  while ($file = readdir($entries)) {
    if ($file != "." && $file != "..") {
      $files[] = $file; 
    }  
  }
  rsort($files); /* turn things around the right way */
  for (reset ($files); list ($key, $value) = each ($files); ) {
    // Display title with link
    $modify = $value;
    $msg = file("$newsdir/$value");
    $msg[] = $value;
    for (reset ($msg); list ($key, $value) = each ($msg); ) {
      if ($key == "0") { /* Title */
        echo "<TABLE BORDER=0 CELLSPACING=0 CELLPADDING=0><TR><TD WIDTH=450 VALIGN=TOP>";
        echo "<DIV CLASS=headline>$value</DIV>";
      }
    }
    for (reset ($msg); list ($key, $value) = each ($msg); ) {
      if ($key == "1") { /* Date */
        // Display Date, Time & Action
        echo "<DIV CLASS=newsdetail><i>$value</i></DIV>\n";
      }
    }
    for (reset ($msg); list ($key, $value) = each ($msg); ) {
      if ($key >= "2") { /* short Desc */
        if ($value != $modify) {
          echo "<DIV CLASS=normal></b>$value\n";
        }
      }
    }
    echo "<TD VALIGN=TOP><DIV CLASS=normal>[<A HREF=news.php?mode=edit_or_delete&todo=edit&entry=$modify>Edit</A>/<A HREF=news.php?mode=edit_or_delete&todo=delete&entry=$modify>Delete</A>]</DIV></TD>";
    echo "</TD></TR></TABLE>";
    echo "<HR>";
  }
  // Finish things off
  closedir($entries);
  break;

case 'edit_or_delete':
  if ($todo == "edit") {  /* We're editing it now */
    $files = array();           
    $msg = file("$newsdir/$entry");
    $msg[] = $value;
    echo "<DIV CLASS=headline>Editing News</DIV><HR>";
    echo "<DIV CLASS=normal><FORM NAME=edit action=$PHP_SELF?mode=edit_confirm method=post>";
    echo "<INPUT TYPE=hidden NAME=editing VALUE='$newsdir/$entry'>";
    for (reset ($msg); list ($key, $value) = each ($msg); ) {
      if ($key == "0") { /* Title */
        echo "<DIV CLASS=normal><B>Title:</B><BR><INPUT NAME=title TYPE=text SIZE=40 VALUE='$value'><BR>\n";
      }
      if ($key == "1") { /* Date */
        echo "<INPUT NAME=date TYPE=hidden VALUE='$value'>\n";
      }
      if ($key == "2") { /* Create Textbox */
        echo "<P><B>Full Text:</B><BR><TEXTAREA name=contents rows=10 cols=55 wrap=none>\n";
      }
      if ($key >= "2") { /* Fill it up */
        echo "$value";
      }
    }
    echo "</TEXTAREA>";
    echo "<P><INPUT name=submit type=submit value='Edit Entry'>";
    echo "</FORM>";
  }

  if ($todo == "delete") {    /* Delete the file */
    $deleting_file = unlink( $newsdir . '/' . $entry );
    echo "<DIV CLASS=headline>Deleting Entry</DIV><HR>";
    echo "<DIV CLASS=normal>Entry Deleted<p><A HREF=$PHP_SELF?mode=index>Back</A>";
  }
  break;

case 'edit_confirm':
  echo "<DIV CLASS=headline>Editing News</DIV><HR>";
  echo "<DIV CLASS=normal>Your entry has been edited<P><A HREF=$PHP_SELF?mode=index>Back</A>";
  // what to do with the form data 
  if ($contents) {
    if ($title == '') { $title = "Untitled"; }
    $title = stripslashes($title);
    $contents = stripslashes($contents);
    $contents = ereg_replace("\r\n", "\n<BR>", $contents);
    $contents = "$title\n$date\n$contents";
    if ($fp = fopen("$editing", 'w')) {
      fwrite ($fp, $contents);
    }
  }
  break;

// Adding a new entry.
case 'add_entry':
  echo "<DIV CLASS=headline>Adding News</DIV><HR>";
  echo "<div align=LEFT><FORM action=$PHP_SELF?mode=addentry_confirm method=post>";
  echo "<DIV CLASS=normal><b>Entry Title:</b><BR><INPUT name=title type=text size=40><P>";
  echo "<b>Full Text:</b><BR><TEXTAREA name=message rows=10 cols=55 wrap=none>";
  echo "</TEXTAREA><p>";
  echo "<INPUT TYPE=hidden NAME=email VALUE="; GetUserEmail($login); echo "></INPUT>";
  echo "<INPUT TYPE=hidden NAME=author VALUE="; GetDisplayName($login); echo "></INPUT>";
  echo "<INPUT name=submit type=submit value='Create Entry'>";
  echo "</FORM></DIV>";
  break;
	
// Confirm that a entry has been added and write to disk.
case 'addentry_confirm':
  echo "<DIV CLASS=headline>Adding News</DIV><HR>";
  echo "<DIV CLASS=normal>Your entry has been saved<P><A HREF=$PHP_SELF?mode=index>Back</A>";
  // what to do with the form data 
  if ($message) {
    if ($title == '') { $title = "Untitled"; }
    $name = date("mdy_His");
    $newsfile = "$newsdir/$name.txt";
    $title = stripslashes($title);
    $message = stripslashes($message);
    $message = ereg_replace("\r\n", "\n<BR>", $message);
    $date = date("l, F j Y, H:i ");
    $message = "$title\n$date - by: <A HREF=mailto:$email>$author</A>\n$message";
    if ($fp = fopen("$newsfile", 'w')) {
      fwrite ($fp, $message);
    }
  }
  break;
}

}
?>
